git-rebase.shon commit rebase: extend --signoff support (a852ec7)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6SUBDIRECTORY_OK=Yes
   7OPTIONS_KEEPDASHDASH=
   8OPTIONS_STUCKLONG=t
   9OPTIONS_SPEC="\
  10git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
  11git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
  12git rebase --continue | --abort | --skip | --edit-todo
  13--
  14 Available options are
  15v,verbose!         display a diffstat of what changed upstream
  16q,quiet!           be quiet. implies --no-stat
  17autostash          automatically stash/stash pop before and after
  18fork-point         use 'merge-base --fork-point' to refine upstream
  19onto=!             rebase onto given branch instead of upstream
  20p,preserve-merges! try to recreate merges instead of ignoring them
  21s,strategy=!       use the given merge strategy
  22no-ff!             cherry-pick all commits, even if unchanged
  23m,merge!           use merging strategies to rebase
  24i,interactive!     let the user edit the list of commits to rebase
  25x,exec=!           add exec lines after each commit of the editable list
  26k,keep-empty       preserve empty commits during rebase
  27f,force-rebase!    force rebase even if branch is up to date
  28X,strategy-option=! pass the argument through to the merge strategy
  29stat!              display a diffstat of what changed upstream
  30n,no-stat!         do not show diffstat of what changed upstream
  31verify             allow pre-rebase hook to run
  32rerere-autoupdate  allow rerere to update index with resolved conflicts
  33root!              rebase all reachable commits up to the root(s)
  34autosquash         move commits that begin with squash!/fixup! under -i
  35committer-date-is-author-date! passed to 'git am'
  36ignore-date!       passed to 'git am'
  37signoff            passed to 'git am'
  38whitespace=!       passed to 'git apply'
  39ignore-whitespace! passed to 'git apply'
  40C=!                passed to 'git apply'
  41S,gpg-sign?        GPG-sign commits
  42 Actions:
  43continue!          continue
  44abort!             abort and check out the original branch
  45skip!              skip current patch and continue
  46edit-todo!         edit the todo list during an interactive rebase
  47quit!              abort but keep HEAD where it is
  48"
  49. git-sh-setup
  50set_reflog_action rebase
  51require_work_tree_exists
  52cd_to_toplevel
  53
  54LF='
  55'
  56ok_to_skip_pre_rebase=
  57resolvemsg="
  58$(gettext 'Resolve all conflicts manually, mark them as resolved with
  59"git add/rm <conflicted_files>", then run "git rebase --continue".
  60You can instead skip this commit: run "git rebase --skip".
  61To abort and get back to the state before "git rebase", run "git rebase --abort".')
  62"
  63squash_onto=
  64unset onto
  65unset restrict_revision
  66cmd=
  67strategy=
  68strategy_opts=
  69do_merge=
  70merge_dir="$GIT_DIR"/rebase-merge
  71apply_dir="$GIT_DIR"/rebase-apply
  72verbose=
  73diffstat=
  74test "$(git config --bool rebase.stat)" = true && diffstat=t
  75autostash="$(git config --bool rebase.autostash || echo false)"
  76fork_point=auto
  77git_am_opt=
  78git_format_patch_opt=
  79rebase_root=
  80force_rebase=
  81allow_rerere_autoupdate=
  82# Non-empty if a rebase was in progress when 'git rebase' was invoked
  83in_progress=
  84# One of {am, merge, interactive}
  85type=
  86# One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
  87state_dir=
  88# One of {'', continue, skip, abort}, as parsed from command line
  89action=
  90preserve_merges=
  91autosquash=
  92keep_empty=
  93signoff=
  94test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
  95case "$(git config --bool commit.gpgsign)" in
  96true)   gpg_sign_opt=-S ;;
  97*)      gpg_sign_opt= ;;
  98esac
  99
 100read_basic_state () {
 101        test -f "$state_dir/head-name" &&
 102        test -f "$state_dir/onto" &&
 103        head_name=$(cat "$state_dir"/head-name) &&
 104        onto=$(cat "$state_dir"/onto) &&
 105        # We always write to orig-head, but interactive rebase used to write to
 106        # head. Fall back to reading from head to cover for the case that the
 107        # user upgraded git with an ongoing interactive rebase.
 108        if test -f "$state_dir"/orig-head
 109        then
 110                orig_head=$(cat "$state_dir"/orig-head)
 111        else
 112                orig_head=$(cat "$state_dir"/head)
 113        fi &&
 114        GIT_QUIET=$(cat "$state_dir"/quiet) &&
 115        test -f "$state_dir"/verbose && verbose=t
 116        test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
 117        test -f "$state_dir"/strategy_opts &&
 118                strategy_opts="$(cat "$state_dir"/strategy_opts)"
 119        test -f "$state_dir"/allow_rerere_autoupdate &&
 120                allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
 121        test -f "$state_dir"/gpg_sign_opt &&
 122                gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
 123        test -f "$state_dir"/signoff && {
 124                signoff="$(cat "$state_dir"/signoff)"
 125                force_rebase=t
 126        }
 127}
 128
 129write_basic_state () {
 130        echo "$head_name" > "$state_dir"/head-name &&
 131        echo "$onto" > "$state_dir"/onto &&
 132        echo "$orig_head" > "$state_dir"/orig-head &&
 133        echo "$GIT_QUIET" > "$state_dir"/quiet &&
 134        test t = "$verbose" && : > "$state_dir"/verbose
 135        test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
 136        test -n "$strategy_opts" && echo "$strategy_opts" > \
 137                "$state_dir"/strategy_opts
 138        test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
 139                "$state_dir"/allow_rerere_autoupdate
 140        test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
 141        test -n "$signoff" && echo "$signoff" >"$state_dir"/signoff
 142}
 143
 144output () {
 145        case "$verbose" in
 146        '')
 147                output=$("$@" 2>&1 )
 148                status=$?
 149                test $status != 0 && printf "%s\n" "$output"
 150                return $status
 151                ;;
 152        *)
 153                "$@"
 154                ;;
 155        esac
 156}
 157
 158move_to_original_branch () {
 159        case "$head_name" in
 160        refs/*)
 161                message="rebase finished: $head_name onto $onto"
 162                git update-ref -m "$message" \
 163                        $head_name $(git rev-parse HEAD) $orig_head &&
 164                git symbolic-ref \
 165                        -m "rebase finished: returning to $head_name" \
 166                        HEAD $head_name ||
 167                die "$(eval_gettext "Could not move back to \$head_name")"
 168                ;;
 169        esac
 170}
 171
 172apply_autostash () {
 173        if test -f "$state_dir/autostash"
 174        then
 175                stash_sha1=$(cat "$state_dir/autostash")
 176                if git stash apply $stash_sha1 >/dev/null 2>&1
 177                then
 178                        echo "$(gettext 'Applied autostash.')" >&2
 179                else
 180                        git stash store -m "autostash" -q $stash_sha1 ||
 181                        die "$(eval_gettext "Cannot store \$stash_sha1")"
 182                        gettext 'Applying autostash resulted in conflicts.
 183Your changes are safe in the stash.
 184You can run "git stash pop" or "git stash drop" at any time.
 185' >&2
 186                fi
 187        fi
 188}
 189
 190finish_rebase () {
 191        apply_autostash &&
 192        { git gc --auto || true; } &&
 193        rm -rf "$state_dir"
 194}
 195
 196run_specific_rebase () {
 197        if [ "$interactive_rebase" = implied ]; then
 198                GIT_EDITOR=:
 199                export GIT_EDITOR
 200                autosquash=
 201        fi
 202        . git-rebase--$type
 203        ret=$?
 204        if test $ret -eq 0
 205        then
 206                finish_rebase
 207        elif test $ret -eq 2 # special exit status for rebase -i
 208        then
 209                apply_autostash &&
 210                rm -rf "$state_dir" &&
 211                die "Nothing to do"
 212        fi
 213        exit $ret
 214}
 215
 216run_pre_rebase_hook () {
 217        if test -z "$ok_to_skip_pre_rebase" &&
 218           test -x "$(git rev-parse --git-path hooks/pre-rebase)"
 219        then
 220                "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
 221                die "$(gettext "The pre-rebase hook refused to rebase.")"
 222        fi
 223}
 224
 225test -f "$apply_dir"/applying &&
 226        die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
 227
 228if test -d "$apply_dir"
 229then
 230        type=am
 231        state_dir="$apply_dir"
 232elif test -d "$merge_dir"
 233then
 234        if test -f "$merge_dir"/interactive
 235        then
 236                type=interactive
 237                interactive_rebase=explicit
 238        else
 239                type=merge
 240        fi
 241        state_dir="$merge_dir"
 242fi
 243test -n "$type" && in_progress=t
 244
 245total_argc=$#
 246while test $# != 0
 247do
 248        case "$1" in
 249        --no-verify)
 250                ok_to_skip_pre_rebase=yes
 251                ;;
 252        --verify)
 253                ok_to_skip_pre_rebase=
 254                ;;
 255        --continue|--skip|--abort|--quit|--edit-todo)
 256                test $total_argc -eq 2 || usage
 257                action=${1##--}
 258                ;;
 259        --onto=*)
 260                onto="${1#--onto=}"
 261                ;;
 262        --exec=*)
 263                cmd="${cmd}exec ${1#--exec=}${LF}"
 264                test -z "$interactive_rebase" && interactive_rebase=implied
 265                ;;
 266        --interactive)
 267                interactive_rebase=explicit
 268                ;;
 269        --keep-empty)
 270                keep_empty=yes
 271                ;;
 272        --no-keep-empty)
 273                keep_empty=
 274                ;;
 275        --preserve-merges)
 276                preserve_merges=t
 277                test -z "$interactive_rebase" && interactive_rebase=implied
 278                ;;
 279        --autosquash)
 280                autosquash=t
 281                ;;
 282        --no-autosquash)
 283                autosquash=
 284                ;;
 285        --fork-point)
 286                fork_point=t
 287                ;;
 288        --no-fork-point)
 289                fork_point=
 290                ;;
 291        --merge)
 292                do_merge=t
 293                ;;
 294        --strategy-option=*)
 295                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
 296                do_merge=t
 297                test -z "$strategy" && strategy=recursive
 298                ;;
 299        --strategy=*)
 300                strategy="${1#--strategy=}"
 301                do_merge=t
 302                ;;
 303        --no-stat)
 304                diffstat=
 305                ;;
 306        --stat)
 307                diffstat=t
 308                ;;
 309        --autostash)
 310                autostash=true
 311                ;;
 312        --no-autostash)
 313                autostash=false
 314                ;;
 315        --verbose)
 316                verbose=t
 317                diffstat=t
 318                GIT_QUIET=
 319                ;;
 320        --quiet)
 321                GIT_QUIET=t
 322                git_am_opt="$git_am_opt -q"
 323                verbose=
 324                diffstat=
 325                ;;
 326        --whitespace=*)
 327                git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
 328                case "${1#--whitespace=}" in
 329                fix|strip)
 330                        force_rebase=t
 331                        ;;
 332                esac
 333                ;;
 334        --ignore-whitespace)
 335                git_am_opt="$git_am_opt $1"
 336                ;;
 337        --signoff)
 338                signoff=--signoff
 339                ;;
 340        --no-signoff)
 341                signoff=
 342                ;;
 343        --committer-date-is-author-date|--ignore-date)
 344                git_am_opt="$git_am_opt $1"
 345                force_rebase=t
 346                ;;
 347        -C*)
 348                git_am_opt="$git_am_opt $1"
 349                ;;
 350        --root)
 351                rebase_root=t
 352                ;;
 353        --force-rebase|--no-ff)
 354                force_rebase=t
 355                ;;
 356        --rerere-autoupdate|--no-rerere-autoupdate)
 357                allow_rerere_autoupdate="$1"
 358                ;;
 359        --gpg-sign)
 360                gpg_sign_opt=-S
 361                ;;
 362        --gpg-sign=*)
 363                gpg_sign_opt="-S${1#--gpg-sign=}"
 364                ;;
 365        --)
 366                shift
 367                break
 368                ;;
 369        *)
 370                usage
 371                ;;
 372        esac
 373        shift
 374done
 375test $# -gt 2 && usage
 376
 377if test -n "$action"
 378then
 379        test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
 380        # Only interactive rebase uses detailed reflog messages
 381        if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
 382        then
 383                GIT_REFLOG_ACTION="rebase -i ($action)"
 384                export GIT_REFLOG_ACTION
 385        fi
 386fi
 387
 388if test "$action" = "edit-todo" && test "$type" != "interactive"
 389then
 390        die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
 391fi
 392
 393case "$action" in
 394continue)
 395        # Sanity check
 396        git rev-parse --verify HEAD >/dev/null ||
 397                die "$(gettext "Cannot read HEAD")"
 398        git update-index --ignore-submodules --refresh &&
 399        git diff-files --quiet --ignore-submodules || {
 400                echo "$(gettext "You must edit all merge conflicts and then
 401mark them as resolved using git add")"
 402                exit 1
 403        }
 404        read_basic_state
 405        run_specific_rebase
 406        ;;
 407skip)
 408        output git reset --hard HEAD || exit $?
 409        read_basic_state
 410        run_specific_rebase
 411        ;;
 412abort)
 413        git rerere clear
 414        read_basic_state
 415        case "$head_name" in
 416        refs/*)
 417                git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
 418                die "$(eval_gettext "Could not move back to \$head_name")"
 419                ;;
 420        esac
 421        output git reset --hard $orig_head
 422        finish_rebase
 423        exit
 424        ;;
 425quit)
 426        exec rm -rf "$state_dir"
 427        ;;
 428edit-todo)
 429        run_specific_rebase
 430        ;;
 431esac
 432
 433# Make sure no rebase is in progress
 434if test -n "$in_progress"
 435then
 436        state_dir_base=${state_dir##*/}
 437        cmd_live_rebase="git rebase (--continue | --abort | --skip)"
 438        cmd_clear_stale_rebase="rm -fr \"$state_dir\""
 439        die "
 440$(eval_gettext 'It seems that there is already a $state_dir_base directory, and
 441I wonder if you are in the middle of another rebase.  If that is the
 442case, please try
 443        $cmd_live_rebase
 444If that is not the case, please
 445        $cmd_clear_stale_rebase
 446and run me again.  I am stopping in case you still have something
 447valuable there.')"
 448fi
 449
 450if test -n "$rebase_root" && test -z "$onto"
 451then
 452        test -z "$interactive_rebase" && interactive_rebase=implied
 453fi
 454
 455if test -n "$interactive_rebase"
 456then
 457        type=interactive
 458        state_dir="$merge_dir"
 459elif test -n "$do_merge"
 460then
 461        type=merge
 462        state_dir="$merge_dir"
 463else
 464        type=am
 465        state_dir="$apply_dir"
 466fi
 467
 468if test -t 2 && test -z "$GIT_QUIET"
 469then
 470        git_format_patch_opt="$git_format_patch_opt --progress"
 471fi
 472
 473if test -n "$signoff"
 474then
 475        git_am_opt="$git_am_opt $signoff"
 476        force_rebase=t
 477fi
 478
 479if test -z "$rebase_root"
 480then
 481        case "$#" in
 482        0)
 483                if ! upstream_name=$(git rev-parse --symbolic-full-name \
 484                        --verify -q @{upstream} 2>/dev/null)
 485                then
 486                        . git-parse-remote
 487                        error_on_missing_default_upstream "rebase" "rebase" \
 488                                "against" "git rebase $(gettext '<branch>')"
 489                fi
 490
 491                test "$fork_point" = auto && fork_point=t
 492                ;;
 493        *)      upstream_name="$1"
 494                if test "$upstream_name" = "-"
 495                then
 496                        upstream_name="@{-1}"
 497                fi
 498                shift
 499                ;;
 500        esac
 501        upstream=$(peel_committish "${upstream_name}") ||
 502        die "$(eval_gettext "invalid upstream '\$upstream_name'")"
 503        upstream_arg="$upstream_name"
 504else
 505        if test -z "$onto"
 506        then
 507                empty_tree=$(git hash-object -t tree /dev/null)
 508                onto=$(git commit-tree $empty_tree </dev/null)
 509                squash_onto="$onto"
 510        fi
 511        unset upstream_name
 512        unset upstream
 513        test $# -gt 1 && usage
 514        upstream_arg=--root
 515fi
 516
 517# Make sure the branch to rebase onto is valid.
 518onto_name=${onto-"$upstream_name"}
 519case "$onto_name" in
 520*...*)
 521        if      left=${onto_name%...*} right=${onto_name#*...} &&
 522                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 523        then
 524                case "$onto" in
 525                ?*"$LF"?*)
 526                        die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
 527                        ;;
 528                '')
 529                        die "$(eval_gettext "\$onto_name: there is no merge base")"
 530                        ;;
 531                esac
 532        else
 533                die "$(eval_gettext "\$onto_name: there is no merge base")"
 534        fi
 535        ;;
 536*)
 537        onto=$(peel_committish "$onto_name") ||
 538        die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
 539        ;;
 540esac
 541
 542# If the branch to rebase is given, that is the branch we will rebase
 543# $branch_name -- branch/commit being rebased, or HEAD (already detached)
 544# $orig_head -- commit object name of tip of the branch before rebasing
 545# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 546switch_to=
 547case "$#" in
 5481)
 549        # Is it "rebase other $branchname" or "rebase other $commit"?
 550        branch_name="$1"
 551        switch_to="$1"
 552
 553        # Is it a local branch?
 554        if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
 555           orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
 556        then
 557                head_name="refs/heads/$branch_name"
 558        # If not is it a valid ref (branch or commit)?
 559        elif orig_head=$(git rev-parse -q --verify "$branch_name")
 560        then
 561                head_name="detached HEAD"
 562
 563        else
 564                die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
 565        fi
 566        ;;
 5670)
 568        # Do not need to switch branches, we are already on it.
 569        if branch_name=$(git symbolic-ref -q HEAD)
 570        then
 571                head_name=$branch_name
 572                branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
 573        else
 574                head_name="detached HEAD"
 575                branch_name=HEAD
 576        fi
 577        orig_head=$(git rev-parse --verify HEAD) || exit
 578        ;;
 579*)
 580        die "BUG: unexpected number of arguments left to parse"
 581        ;;
 582esac
 583
 584if test "$fork_point" = t
 585then
 586        new_upstream=$(git merge-base --fork-point "$upstream_name" \
 587                        "${switch_to:-HEAD}")
 588        if test -n "$new_upstream"
 589        then
 590                restrict_revision=$new_upstream
 591        fi
 592fi
 593
 594if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
 595then
 596        stash_sha1=$(git stash create "autostash") ||
 597        die "$(gettext 'Cannot autostash')"
 598
 599        mkdir -p "$state_dir" &&
 600        echo $stash_sha1 >"$state_dir/autostash" &&
 601        stash_abbrev=$(git rev-parse --short $stash_sha1) &&
 602        echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
 603        git reset --hard
 604fi
 605
 606require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
 607
 608# Now we are rebasing commits $upstream..$orig_head (or with --root,
 609# everything leading up to $orig_head) on top of $onto
 610
 611# Check if we are already based on $onto with linear history,
 612# but this should be done only when upstream and onto are the same
 613# and if this is not an interactive rebase.
 614mb=$(git merge-base "$onto" "$orig_head")
 615if test "$type" != interactive && test "$upstream" = "$onto" &&
 616        test "$mb" = "$onto" && test -z "$restrict_revision" &&
 617        # linear history?
 618        ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
 619then
 620        if test -z "$force_rebase"
 621        then
 622                # Lazily switch to the target branch if needed...
 623                test -z "$switch_to" ||
 624                GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
 625                        git checkout -q "$switch_to" --
 626                if test "$branch_name" = "HEAD" &&
 627                         ! git symbolic-ref -q HEAD
 628                then
 629                        say "$(eval_gettext "HEAD is up to date.")"
 630                else
 631                        say "$(eval_gettext "Current branch \$branch_name is up to date.")"
 632                fi
 633                finish_rebase
 634                exit 0
 635        else
 636                if test "$branch_name" = "HEAD" &&
 637                         ! git symbolic-ref -q HEAD
 638                then
 639                        say "$(eval_gettext "HEAD is up to date, rebase forced.")"
 640                else
 641                        say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
 642                fi
 643        fi
 644fi
 645
 646# If a hook exists, give it a chance to interrupt
 647run_pre_rebase_hook "$upstream_arg" "$@"
 648
 649if test -n "$diffstat"
 650then
 651        if test -n "$verbose"
 652        then
 653                echo "$(eval_gettext "Changes from \$mb to \$onto:")"
 654        fi
 655        # We want color (if set), but no pager
 656        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 657fi
 658
 659test "$type" = interactive && run_specific_rebase
 660
 661# Detach HEAD and reset the tree
 662say "$(gettext "First, rewinding head to replay your work on top of it...")"
 663
 664GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
 665        git checkout -q "$onto^0" || die "could not detach HEAD"
 666git update-ref ORIG_HEAD $orig_head
 667
 668# If the $onto is a proper descendant of the tip of the branch, then
 669# we just fast-forwarded.
 670if test "$mb" = "$orig_head"
 671then
 672        say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
 673        move_to_original_branch
 674        finish_rebase
 675        exit 0
 676fi
 677
 678if test -n "$rebase_root"
 679then
 680        revisions="$onto..$orig_head"
 681else
 682        revisions="${restrict_revision-$upstream}..$orig_head"
 683fi
 684
 685run_specific_rebase